/***********************************************/
/* Software Created By CKJ Vincent Cedric      */
/* This code is the property of Vincent Cedric */
/* You can't copy or use this code without     */
/* according of the author (GPL License).	   */
/***********************************************/
#ifndef _CCOLUMNVIEW_H
#define _CCOLUMNVIEW_H
/******************************/
/* classe ColumnView speciale */
/******************************/
#include <interface/View.h>
#include <support/String.h>
#include <support/List.h>

// constantes
#define		SIZE_START_COLOMN		11
#define		SIZE_LABEL_MORE			20
#define		EDGE_RESIZE				6

class BListView;
class CColumnItem;
class BCursor;

class CColumnView : public BView
{
// fonctions
public:
	CColumnView(const char *name,BCursor *resizeCursor = NULL,bool lockColumn = false,bool lastColumnComplete = false);
	virtual ~CColumnView();

	virtual void			AttachedToWindow();																// attachement a la vue parente
	virtual void			Draw(BRect updateRect);															// dessin des colonnes
	virtual	void			MouseDown(BPoint point);														// clique souris
	virtual	void			MouseMoved(BPoint point,uint32 transit,const BMessage *message);				// deplacement de la souris
			bool			AddItem(CColumnItem *newItem,float neededSize = 0);								// ajouter une colonne

	inline	int32			CountItems()				{ return _itemList.CountItems(); }	
	inline	CColumnItem		*ItemAt(int32 index)		{ return (CColumnItem *)(_itemList.ItemAt(index)); }
	inline	CColumnItem		*RemoveItem(int32 index)	{ return (CColumnItem *)(_itemList.RemoveItem(index)); }
	inline	BRect			*RectFrom(int32 index)		{ return (BRect *)(_itemListRect.ItemAt(index)); }

protected:
	BList		_itemList;				// liste des colonnes
	BList		_itemListRect;			// liste des rectangle dans lesquels se trouvent les colonnes
	bool		_lastColumnComplete;	// si on veux que la derniere colonne soit sans fin
	bool		_lockColumn;			// bloquer toutes les colonnes, interdire la redimentionnement
	bool		_columnIsInResize;		// si on est en train de redimentionner une colonne
	bool		_attachFirstTime;		// si c'est le premier appel de attachToWindow
	BCursor		*_resizeCursor;			// forme resize du curseur
	BListView	*_listView;				// liste support des items a redimentionner

			status_t	ResizeColumnTo(BPoint &where,int32 &startIndex);	// redimentionner la colonne a partir d'un index de colonne
			int32		InColumnResizeArea(BPoint where);					// trouver si on se trouve dans la zone de redimentionnement d'une colonne
};

#endif
