/***********************************************/
/* Software Created By CKJ Vincent Cedric      */
/* This code is the property of Vincent Cedric */
/* You can't copy or use this code without     */
/* according of the author (GPL License).	   */
/***********************************************/
/*****************************/
/* classe CMenuItem speciale */
/*****************************/
#include "CMenuItem.h"

/**** constructeur ****/
CMenuItem::CMenuItem(const char *label,BMessage *message,char shortcut, uint32 modifiers)
: BMenuItem(label,message,shortcut,modifiers)
{
	// initialiser
	_menuColor = (rgb_color){0,0,0,255};
	_viewColor = (rgb_color){255,255,255,255};
	_stepR = 0;
	_stepG = 0;
	_stepB = 0;
}

void CMenuItem::Draw(void)
{
	// on doit dessiner au moins la marque
	BMenuItem::Draw();
	
	if(IsSelected())
		return;
		
	_oldColor = Menu()->HighColor();
	_viewColor = Menu()->ViewColor();
	_drawColor = _viewColor;

	// calculer le pas
	ComputeColorSteps();

	// dessiner le degradé
	_frame = Frame();
	_frame.left--;
	for(int8 i=RASTER_SIZE;i>0;i--)
	{
		// augmenter la couleur
		_drawColor.red +=_stepR;
		_drawColor.green +=_stepG;
		_drawColor.blue +=_stepB;
		
		Menu()->SetHighColor(_drawColor);
		Menu()->StrokeLine(BPoint(_frame.left+i,_frame.top),BPoint(_frame.left+i,_frame.bottom));
	}
	
	// restaurer la couleur
	Menu()->SetHighColor(_oldColor);
}

/**** calculer les pas ****/
void CMenuItem::ComputeColorSteps()
{
	bool	notDiff = true;
	
	notDiff &= _menuColor.red == _viewColor.red;
	notDiff &= _menuColor.green == _viewColor.green;
	notDiff &= _menuColor.blue == _viewColor.blue;
	if(!notDiff)
	{
		_stepR = (int8)((255 - _viewColor.red) / RASTER_SIZE);
		_stepG = (int8)((255 - _viewColor.green) / RASTER_SIZE);
		_stepB = (int8)((255 - _viewColor.blue) / RASTER_SIZE);
		
		// garder la couleur actuelle
		_menuColor = _viewColor;
	}
}
