/***********************************************/
/* Software Created By CKJ Vincent Cedric      */
/* This code is the property of Vincent Cedric */
/* You can't copy or use this code without     */
/* according of the author (GPL License).	   */
/***********************************************/

/*****************************/
/* classe SatusView speciale */
/*****************************/
#include "CStatusView.h"
#include "CStatusItem.h"

// pour les couleurs
#include "CGlobalDefs.h"

/**** Constructeur ****/
CStatusView::CStatusView(BRect frame,const char *name)
: BView(frame,name,B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM,B_WILL_DRAW)
{
	// fixer la couleur de fond
	SetViewColor(VIEW_COLOR);
}

/**** Destructeur ****/
CStatusView::~CStatusView()
{
}

/**** dessin de la vue ****/
void CStatusView::Draw(BRect updateRect)
{
	CStatusItem		*item = NULL;
	BRect			bounds = Bounds();
	BPoint			start;
	BRect			itemRect;

	// le fond
	bounds.InsetBy(1,1);
	SetHighColor(ViewColor());
	FillRect(bounds);

	// les items
	for(int32 index=0;index<_itemList.CountItems();index++)
	{
		item = (CStatusItem *)(_itemList.ItemAt(index));
		start = item->Start();
		itemRect.Set(start.x,start.y,start.x+item->Width(),start.y+item->Height());
//		itemRect = *((BRect *)(_rectList.ItemAt(index)));
		if(item!=NULL)
			item->DrawItem(this,itemRect);
	}
}

/**** Ajouter un item ****/
bool CStatusView::AddItem(CStatusItem *newItem)
{
	// il faut tout de meme donner un item
	if(newItem==NULL)
		return false;

	CStatusItem	*item = NULL;
	BRect		bounds = Bounds();
	int32		nbItem;
	float		start;

	// on va retenir ou l'on va placer l'item
	// on le place en fonction du precedent et de ca taille
	start = 0;
	nbItem = _itemList.CountItems();
	if(nbItem>0)
	{
		item = (CStatusItem *)(_itemList.ItemAt(nbItem-1));
		if(item!=NULL)
			start = (item->Start()).x + item->Width();
	}
	start++;
	newItem->SetStart(BPoint(start,bounds.top));
	newItem->SetSize(newItem->Width(),bounds.Height());

	// on doit savoir si ca a marché
	return _itemList.AddItem(newItem);
}

/**** Acceder a un item ****/
CStatusItem *CStatusView::ItemAt(int32 index)
{
	// on utilise les metodes de la liste
	return (CStatusItem *)(_itemList.ItemAt(index));
}

/**** Trouver l'index d'un item ****/
int32 CStatusView::IndexOf(CStatusItem *item)
{
	// on utilise les metodes de la liste
	return	_itemList.IndexOf(item);
}

/**** nombre d'items ****/
int32 CStatusView::CountItems()
{
	return _itemList.CountItems();
}

/**** effecer un item ****/
CStatusItem *CStatusView::RemoveItem(int32 index)
{
	// on utilise les metodes de la liste
	return (CStatusItem *)(_itemList.RemoveItem(index));
}
