/***********************************************/
/* Software Created By CKJ Vincent Cedric      */
/* This code is the property of Vincent Cedric */
/* You can't copy or use this code without     */
/* according of the author (GPL License).	   */
/***********************************************/
#include "CUrlView.h"
#include <Roster.h>

//debug
//#include <iostream.h>

/**** constructeur ****/
CUrlView::CUrlView(BRect frame, const char *label, const char *url,url_type type)
: BView(frame,label,B_FOLLOW_LEFT_RIGHT,B_WILL_DRAW | B_FRAME_EVENTS)
{
	_label = label;
	_entered = false;
	_type = type;

	// definir l'url
	SetUrl(url);

	// couleur de fond
	SetViewColor(255,255,255);
}

/**** destructeur ****/
CUrlView::~CUrlView()
{
}

/**** gestion des messages ****/
void CUrlView::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	default:
		BView::MessageReceived(message);	
	}
}

/*** activer l'ouverture du navigateur ****/
void CUrlView::MouseDown(BPoint point)
{
	// l'url ne doit pas etre vide
	if(_url.Length()>0)
	{
		BString		url;
		char		*buffer;

		url = _url;
		switch(_type)
		{
		case WWW_LINK:
			buffer = url.LockBuffer(0);
			be_roster->Launch("text/html", 1, &buffer);
			url.UnlockBuffer();
			break;
		case MAIL_LINK:
			{
				if(url.FindFirst("mailto:")==B_ERROR)
					url.Prepend("mailto:");
			
				buffer = url.LockBuffer(0);
				be_roster->Launch("text/x-email", 1, &buffer);
				url.UnlockBuffer();
			}
			break;
		default:
			; // on fait rien
		}
	}
}

/*** on bouge la souris ****/
void CUrlView::MouseMoved(BPoint point, uint32 transit,const BMessage *message)
{
	switch(transit)
	{
		case B_ENTERED_VIEW:
			_entered = true;
			Invalidate();
			break;
		case B_EXITED_VIEW:
			_entered = false;
			Invalidate();
			break;
		case B_INSIDE_VIEW:
			if(!_entered)
				Invalidate();
	}
}

/*** changer le texte affiché ****/
void CUrlView::SetLabel(const char *label)
{
	_label = label;
}

/**** changer l'url ****/
void CUrlView::SetUrl(const char *url)
{
	_url = url;
}

/**** dessin ****/
void CUrlView::Draw(BRect updateRect)
{
	BRect	bounds = Bounds();

	SetHighColor(ViewColor());
	FillRect(bounds);

	SetLowColor(ViewColor());
	SetHighColor(50,50,170);
	if(_entered)
		SetHighColor(200,0,255);	

	DrawString(_label.String(),BPoint(0,10));
}
